import stack.*;

public class CalcRPN
{
	//Stack<String> s;
	//Stack<Double> s;//voglio controllare PRIMA di mettere sullo stack
	//StackDinamico<Double> s;//voglio controllare PRIMA di mettere sullo stack

	Stack<Double> s;

	public static void main(String[] argv)
	{
		int i;
		double result = (new CalcRPN()).evaluate(argv);
		System.out.print("Il risultato dell'espressione <");
		for(i=0;i<argv.length;i++)
		{
			System.out.print(argv[i] + " ");
		}
		System.out.println("> e' " + result);
	}

	public CalcRPN()
	{
		this(10);
	}

	public CalcRPN(int stackSize)
	{
		//s = new StackStatico<String>(stackSize);
		s = new StackStatico<Double>(stackSize);//voglio controllare PRIMA di mettere sullo stack
		//s = new StackDinamico<Double>();//voglio controllare PRIMA di mettere sullo stack
	}

	public double evaluate(String[] expr)
	{
		int i;
		for(i=0;i<expr.length;i++)
		{
			if(expr[i].equals("+"))
			{
				sum();
			}
			else if(expr[i].equals("-"))
			{
				sub();
			}
			else if(expr[i].equals("X"))
			{
				mul();
			}
			else if(expr[i].equals("/"))
			{
				div();
			}
			else
			{
				// e' un operando
				try
				{
					s.push(new Double(expr[i]));
				}
				catch(NumberFormatException nfe)
				{
					nfe.printStackTrace();
					throw new RuntimeException("<" + expr[i] + "> non e' un operando valido. Stack: " + s.toString()); }
			}
		}
		if(s.howMany() != 1)
		{
			throw new RuntimeException("Espressione non bilanciata");
		}
		return s.pop().doubleValue();
	}

	public void sum()
	{
		Double result, op1, op2;
		System.out.println(s.toString() + " +");
		op2 = s.pop();
		op1 = s.pop();
		result = new Double(op1.doubleValue() + op2.doubleValue());
		//= new Double(s.pop().doubleValue() + s.pop().doubleValue());
		s.push(result);
		System.out.println(s);
	}

	public void sub()
	{
		Double result, op1, op2;
		System.out.println(s.toString() + " -");
		op2 = s.pop();
		op1 = s.pop();
		result = new Double(op1.doubleValue() - op2.doubleValue());
		s.push(result);
		System.out.println(s);
	}

	public void mul()
	{
		Double result, op1, op2;
		System.out.println(s.toString() + " X");
		op2 = s.pop();
		op1 = s.pop();
		result = new Double(op1.doubleValue() * op2.doubleValue());
		s.push(result);
		System.out.println(s);
	}

	public void div()
	{
		Double result, op1, op2;
		System.out.println(s.toString() + " /");
		op2 = s.pop();
		op1 = s.pop();
		result = new Double(op1.doubleValue() / op2.doubleValue());
		s.push(result);
		System.out.println(s);
	}
}
