import stack.*;
import figure.*;

public class StackFigurePiane
{
	public static void main(String[] argv)
	{
		Stack s = new StackDinamico();
		int i;
		for(i=0;i<argv.length;i+=2)
		{
			FiguraPiana fp = null;
			if(argv[i].equals("quadrato"))
			{
				fp = new Quadrato(Double.parseDouble(argv[i+1]));
			}
			else if(argv[i].equals("cerchio"))
			{
				fp = new Cerchio(Double.parseDouble(argv[i+1]));
			}
			if(fp != null)
			{
				System.out.println(s.push(fp));
			}
			else
			{
				System.out.println(s.push(argv[i]));
				
			}
		}
		System.out.println(s);
		while(!s.empty())
		{
			Object o1 = s.pop();
			/*
			double a = ((FiguraPiana)o).area();
			FiguraPiana o = (FiguraPiana)s.pop();
			*/
			if(o1 instanceof FiguraPiana)
			{
				FiguraPiana o = (FiguraPiana)o1;
				if(o instanceof Poligono)
				{
					System.out.println("la figura piana ha " + ((Poligono)o).getNumLati() + " lati");
				}
				double a = o.area();
				System.out.println(o + " di area " + a);
			}
			else
			{
				System.out.println("Di < " + o1 + "> non so dire nulla");
			}
		}
	}
}
