import java.io.*;

public class Stampa
{
	public static void main(String[] argv)
	{
		File f = new File(argv[0]);
		if(! f.exists())
		{
			System.err.println("Il file <" + f + "> non esiste");
			System.exit(1);
		}

		FileReader fr = null;
		try
		{
			fr = new FileReader(f);
		}
		catch(FileNotFoundException fnfe)
		{
			fnfe.printStackTrace();
			System.exit(1);
		}
		BufferedReader br = new BufferedReader(fr);

		String line = null;

		try
		{
			while( (line = br.readLine()) != null)
			{
				System.out.println(line);
			}
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}

		try
		{
			br.close();
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}
	}
}
