import java.io.*;

public class Studente
implements Comparable
{
	public String matricola;
	public String nome;
	public String cognome;
	public int annoDiNascita;

	public int compareTo(Object o)
	{
		Studente s = (Studente)o;
		return matricola.compareTo(s.matricola);
	}

	public boolean populate(java.io.BufferedReader br)
	{
		try
		{
			String line = br.readLine();
			if(line == null)
			{
				return false;
			}
			matricola = line;

			line = br.readLine();
			if(line == null)
			{
				return false;
			}
			nome = line;

			line = br.readLine();
			if(line == null)
			{
				return false;
			}
			cognome = line;

			line = br.readLine();
			if(line == null)
			{
				return false;
			}
			annoDiNascita = Integer.parseInt(line);
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
			return false;
		}
		catch(NumberFormatException nfe)
		{
			nfe.printStackTrace();
			return false;
		}
		return true;
	}

	public String toString()
	{
		return matricola + "\n" + nome + "\n" + cognome + "\n" + annoDiNascita + "\n";
	}
}
