package dinamiche;

public class BiNodo<E>
{
	protected E dato;
	protected BiNodo<E> next;
	protected BiNodo<E> prev;

	public BiNodo(E ilDato, BiNodo<E> ilPrec, BiNodo<E> ilProssimo)
	{
		dato = ilDato;
		prev = ilPrec;
		next = ilProssimo;
	}

	public BiNodo(E ilDato)
	{
		this(ilDato, null, null);
	}

	BiNodo()
	{
		this(null, null, null);
	}

	public BiNodo<E> getPrev()
	{
		return prev;
	}

	public void setPrev(BiNodo<E> ilPrec)
	{
		prev = ilPrec;
	}

	public BiNodo<E> getNext()
	{
		return next;
	}

	public void setNext(BiNodo<E> nuovoProssimo)
	{
		next = nuovoProssimo;
	}

	public E getDato()
	{
		return dato;
	}

	public boolean equals(Object o)
	{
		return dato.equals( ((BiNodo)o).dato);
	}

	public String toString()
	{
		if(dato == null)
		{
			return "Il binodo contiene <null>";
		}
		return "Il binodo contiene <" + dato.toString()+ ">";
	}
}
